<!DOCTYPE html>
<html>
  <head>
    <title>Operaciones CSG</title>
    <style>
      html, body { margin: 0; padding: 0; overflow: hidden; }
    </style>
  </head>
  <body>
    <script src="js/three.js"></script>
	<script src="js/controls/OrbitControls.js"></script>
	<script src="js/csg.js"></script>
	<script src="js/THREE.CSG.js"></script>
    <script>
		var scene, aspect, camera, renderer, controls;
		init();
		animate();
		function init(){
			//INICIALIZACIÓN
	        scene = new THREE.Scene();
	        aspect = window.innerWidth / window.innerHeight;
	        camera = new THREE.PerspectiveCamera( 75, aspect, 0.1, 1000);
	        renderer = new THREE.WebGLRenderer();
	        renderer.setSize( window.innerWidth, window.innerHeight );
	        document.body.appendChild( renderer.domElement );
			controls = new THREE.OrbitControls( camera, renderer.domElement );
			
			//ELEMENTOS COMUNES
			var size = 10;
			var arrowSize = 1;
			var divisions = size;
			var origin = new THREE.Vector3( 0, 0, 0 );
			var x = new THREE.Vector3( 1, 0, 0 );
			var y = new THREE.Vector3( 0, 1, 0 );
		  	var z = new THREE.Vector3( 0, 0, 1 );
		  	var color = new THREE.Color( 0x333333 );
		  	var colorR = new THREE.Color( 0xAA3333 );
		  	var colorG = new THREE.Color( 0x33AA33 );
		  	var colorB = new THREE.Color( 0x333366 );
			
		  	//CREAR LAS GRILLAS PARA EL ESCENARIO
		  	var axesHelper = new THREE.AxesHelper( size );
			scene.add( axesHelper );
			
		  	var gridHelperXZ = new THREE.GridHelper( size, divisions, color, color );
			scene.add( gridHelperXZ );
            
            //ROTARLAS PARA QUE QUEDEN EN EL ESPACIO ADECUADO
            gridHelperXZ.rotateOnWorldAxis ( y, THREE.Math.degToRad(90) );

            //CREAR ILUMINACIÓN
            var ambient = new THREE.AmbientLight( 0xffffff, 2 );
            scene.add( ambient );
			
            var pointLight = new THREE.PointLight( 0xffffff, 1, 100 );
            pointLight.position.set( -5, -2, 5 );
            scene.add( pointLight );
			
            var pointLight = new THREE.PointLight( 0xffffff, .5, 100 );
            pointLight.position.set( 5, -2, -5 );
            scene.add( pointLight );
			
			//CREAR LAS GEOMETRÍAS
			var boxGeometry = new THREE.BoxGeometry( 5, 2, 1 );
			var boxGeometry4 = new THREE.BoxGeometry( 4, 2, 0.4 );
			var boxGeometry2 = new THREE.BoxGeometry( 1, 1.1, 2 ); 
			var boxGeometry3 = new THREE.BoxGeometry( 1, 1.2, 2 );
			var sphereGeometry = new THREE.SphereGeometry( 0.9, 32, 32 );
			var cyligeometry = new THREE.CylinderGeometry( .45, .45, 3,32 );
			var cyligeometry2 = new THREE.CylinderGeometry( .225, .225, 1.5,32 );
			var cyligeometry3 = new THREE.CylinderGeometry( .225, .225, 1.5,32 );
			var cyligeometry4 = new THREE.CylinderGeometry( .225, .225, 2,32 );
			var cyligeometry5 = new THREE.CylinderGeometry( .225, .225, 2,32 );
			var cyligeometry6 = new THREE.CylinderGeometry( 1, 1, 1,32 );
			var toroide = new THREE.TorusGeometry( 1, 0.25, 16, 100 );
			var toroide2 = new THREE.TorusGeometry( 1, 0.25, 16, 100);
			
			//CREAR LOS MATERIALES
            var material1 = new THREE.MeshStandardMaterial( { color: colorR, metalness: 0.5, roughness: 0.1 } );
			var material2 = new THREE.MeshStandardMaterial( { color: colorG, metalness: 0.5, roughness: 0.1, transparent:true, opacity: 0.5  } );
			
			//CREAR LAS MALLAS
			var cube = new THREE.Mesh( boxGeometry );
			cube.rotation.x=Math.PI / 2;
			var cube4 = new THREE.Mesh( boxGeometry4 );
			cube4.rotation.x=Math.PI / 2;
			cube4.translateZ( 0.3);
			var cube2 = new THREE.Mesh( boxGeometry2 );
			cube2.translateY( 1);
			var cube3 = new THREE.Mesh( boxGeometry3 );
			cube3.translateY( 2);
			//cube2.rotation.x=Math.PI / 2;
			var sphere = new THREE.Mesh( sphereGeometry );
			sphere.translateY( 1.5);
			var toro= new THREE.Mesh( toroide );
		    toro.rotation.x=Math.PI / 2
			toro.position.x=-0.5;
			var toro2= new THREE.Mesh( toroide2 );
			var cyli = new THREE.Mesh( cyligeometry );
			cyli.rotation.x=Math.PI / 2;
			cyli.rotation.z=Math.PI / 2;
			cyli.translateZ( -1.5 );
			var cyli2 = new THREE.Mesh( cyligeometry2 );
			cyli2.translateX( -1.2 );
			var cyli3 = new THREE.Mesh( cyligeometry3 );
			cyli3.translateX( 1.2 );
			var cyli4 = new THREE.Mesh( cyligeometry4 );
			cyli4.rotation.x=Math.PI / 2;
			cyli4.translateX( -2.3 );
			cyli4.translateZ(-.29 );
			var cyli5 = new THREE.Mesh( cyligeometry5 );
			cyli5.rotation.x=Math.PI / 2;
			cyli5.translateX( 2.3 );
			cyli5.translateZ(-.29 );
			var cyli6 = new THREE.Mesh( cyligeometry6 );
			cyli6.rotation.x=Math.PI / 2;
			cyli6.rotation.z=Math.PI / 2;
			cyli6.translateZ( -1.5 );
			var cyli7 = new THREE.Mesh( cyligeometry5 );
			cyli7.rotation.x=Math.PI / 2;
			cyli7.translateX( .54 );
			cyli7.translateZ(-.62 );
			var cyli8 = new THREE.Mesh( cyligeometry5 );
			cyli8.rotation.x=Math.PI / 2;
			cyli8.translateX( -.6 );
			cyli8.translateZ(-.4 );
			//CONVERTIR A CSG
			var boxCSG = THREE.CSG.fromMesh( cube );
			var boxCSG2 = THREE.CSG.fromMesh( cube2 );
			var sphereCSG = THREE.CSG.fromMesh( sphere );
			var toroideCSG = THREE.CSG.fromMesh( toro);
			var cyliCSG = THREE.CSG.fromMesh( cyli );
			var cyli6CSG = THREE.CSG.fromMesh( cyli6 );
			var cyli7CSG = THREE.CSG.fromMesh( cyli7 );
			var cyli8CSG = THREE.CSG.fromMesh( cyli8 );
			//APLICAR LAS OPERACIONES
			var result1 = boxCSG.subtract( sphereCSG );	//CAJA MENOS ESFERA
			var result2= boxCSG.intersect( sphereCSG );	//INTERSECCIÓN - CAJA Y ESFERA
			var result3 = boxCSG.union( sphereCSG );	//UNIÓN - CAJA Y ESFERA0
			var result4 = sphereCSG.subtract( boxCSG );	//ESFEENOSRA M CAJA
			var result5 = boxCSG2.union( cyliCSG );
			//var result5 = sphereCSG.subtract( boxCSG2 );
			var result6 = result5.union(cyli6CSG);
			var result7 = result6.subtract(cyliCSG);
			var result8 = boxCSG2.subtract(cyli8CSG);
			//CONVERTIR A MALLA DE THREE JS NUEVAMENTE
			var C2T1 = THREE.CSG.toMesh( result1 );
			var C2T2 = THREE.CSG.toMesh( result2 );
			var C2T3 = THREE.CSG.toMesh( result3 );
			var C2T4 = THREE.CSG.toMesh( result4 );
			var C2T42 = THREE.CSG.toMesh( result5 );
			var C2T422 = THREE.CSG.toMesh( result6 );
			var C2T4222 = THREE.CSG.toMesh( result7 );
			var C2T42223 = THREE.CSG.toMesh( result8 );
			C2T1.material = material1; 
			C2T2.material = material1; 
			C2T3.material = material1; 
			C2T4.material = material1; 
			C2T42.material = material1;
			C2T422.material = material1;
			C2T4222.material = material1;
			C2T42223.material = material1;
			cube.material = material2;
			cube2.material = material1;
			cube3.material = material1;
			cube4.material = material1;
			cyli.material= material2;
			cyli2.material= material1;
			cyli3.material= material1;
			cyli4.material= material1;
			cyli5.material= material1;
			cyli6.material= material1;
			cyli7.material= material2;
			cyli8.material= material2;
			sphere.material = material2;
			
			C2T1.translateX(2);
			C2T2.translateX(-2);
			C2T3.translateZ(2);
			C2T4.translateZ(-2);
			C2T42.translateZ(-3);
			C2T422.translateZ(3);
			C2T4222.translateX(5);
			C2T42223.translateY(3);
			//AGREGAR A LA ESCENA LOS DIFERENTES ELEMENTOS
			scene.add( cube );			//ACTIVAR PARA VISUALIZAR EL CUBO
			scene.add( cube2 );
			//scene.add( cube3 );
			scene.add( cube4 );
			scene.add( cyli );
			scene.add( cyli2 );
			scene.add( cyli3 );
			scene.add( cyli4 );
			scene.add( cyli5 );
			scene.add( cyli6 );
			scene.add( cyli7 );
			scene.add( cyli8 );
			//scene.add( C2T1 );
			//scene.add( C2T2 );
			//scene.add( C2T3 );
			scene.add( C2T42 );
			scene.add( C2T422 );
			scene.add( C2T4222 );
			scene.add( C2T42223 );
			//scene.add( sphere );		//ACTIVAR PARA VISUALIZAR LA ESFERA
			//scene.add( toro );
			//scene.add( toro2 );
			camera.position.x = 0;
			camera.position.y = 10;
		  	camera.position.z = 10;
			camera.lookAt( origin );
		}
		function animate(){
			requestAnimationFrame( animate );
			controls.update();
			render();
		}
		function render(){
			renderer.render( scene, camera );
		}
    </script>
  </body>
</html>
